## opensips-3.6.0-1.src.tar.gz

=== Makefile ===
#
# OpenSIPS makefile
#
# WARNING: requires gmake (GNU Make)
#  Arch supported: Linux, FreeBSD, SunOS (tested on Solaris 8), OpenBSD (3.2),
#  NetBSD (1.6).
#
#  History:
#  --------
#              created by andrei
#  2003-02-24  make install no longer overwrites opensips.cfg  - patch provided
#               by Maxim Sobolev   <sobomax@FreeBSD.org> and
#                  Tomas Bjoerklund <tomas@webservices.se>
#  2003-03-11  PREFIX & LOCALBASE must also be exported (andrei)
#  2003-04-07  hacked to work with solaris install (andrei)
#  2003-04-17  exclude modules overwritable from env. or cmd. line,
#               added include_modules and skip_modules (andrei)
#  2003-05-30  added extra_defs & EXTRA_DEFS
#               Makefile.defs force-included to allow recursive make
#               calls -- see comment (andrei)
#  2003-06-02  make tar changes -- unpacks in $NAME-$RELEASE  (andrei)
#  2003-06-03  make install-cfg will properly replace the module path
#               in the cfg (re: /usr/.*lib/opensips/modules)
#              opensips.cfg.default is installed only if there is a previous
#               cfg. -- fixes packages containing opensips.cfg.default (andrei)
#  2003-08-29  install-modules-doc split from install-doc, added
#               install-modules-all, removed README.cfg (andrei)
#              added skip_cfg_install (andrei)
#  2004-09-02  install-man will automatically "fix" the path of the files
#               referred in the man pages
#  2007-09-28  added db_berkeley (wiquan)
#

#SQLITE_BIND=1
NICER?=1
auto_gen=lex.yy.c cfg.tab.c   #lexx, yacc etc

# whether or not to install opensips.cfg or just opensips.cfg.default
# (opensips.cfg will never be overwritten by make install, this is useful
#  when creating packages)
skip_cfg_install?=

#extra modules to exclude
skip_modules?=

# whether or not to overwrite TLS certificates
tls_overwrite_certs?=

makefile_defs=0
DEFS:= $(DEFS_EXTRA_OPTS)
DEBUG_PARSER?=

# create the template only if the file is not yet created
ifeq (,$(wildcard Makefile.conf))
$(shell cp Makefile.conf.template Makefile.conf)
endif
include Makefile.conf

ifneq (,$(findstring SHM_EXTRA_STATS, $(DEFS)))
MEM_STATS_HDR = mem/mem_stats.h
deps_gen += $(MEM_STATS_HDR)
auto_gen += mem/mem_stats.c
endif

dbg_objs=lib/dbg/struct_hist.c

include Makefile.sources
include Makefile.defs

# always exclude the SVN dir
override exclude_modules+= .svn $(skip_modules)

#always include this modules
#include_modules?=

# first 2 lines are excluded because of the experimental or incomplete
# status of the modules
# the rest is excluded because it depends on external libraries
#
static_modules=
static_modules_path=$(addprefix modules/, $(static_modules))
extra_sources=$(wildcard $(addsuffix /*.c, $(static_modules_path)))
extra_objs=$(extra_sources:.c=.o)

static_defs=$(foreach mod, $(static_modules), \
		-DSTATIC_$(shell echo $(mod) | tr [:lower:] [:upper:]) )

override extra_defs+=$(static_defs) $(EXTRA_DEFS)
export extra_defs

# If modules is supplied, only do those. If not, use all modules when
# building documentation.
ifeq ($(modules),)
	doc_modules=$(all_modules)
else
	doc_modules=$(modules)
endif

# Take subset of all modules, excluding the exclude_modules and the
# static_modules.
modules=$(filter-out $(addprefix modules/, \
			$(exclude_modules) $(static_modules)), \
			$(wildcard modules/*))
# Let modules consist of modules and include_modules (but remove
# duplicates).
modules:=$(filter-out $(modules), $(addprefix modules/, $(include_modules) )) \
			$(modules)

ifneq ($(module),)
	modules:=$(addprefix modules/, $(module))
endif

modules_names=$(patsubst modules/%, %.so, $(modules))
modules_basenames=$(patsubst modules/%, %, $(modules))
db_modules_basenames=$(filter db_%, $(modules_basenames))
modules_full_path=$(join $(modules), $(addprefix /, $(modules_names)))

ALLDEP=Makefile Makefile.sources Makefile.defs Makefile.rules Makefile.conf $(deps_gen)

install_docs := AUTHORS NEWS README
ifneq ($(skip-install-doc),yes)
	install_docs += INSTALL
endif

#include general defs (like CC, CFLAGS  a.s.o)
# hack to force makefile.defs re-inclusion (needed when make calls itself with
# other options -- e.g. make bin)
#DEFS:=
#include Makefile.defs

NAME=$(MAIN_NAME)

#export relevant variables to the sub-makes
export DEFS PROFILE CC LD MKDEP MKTAGS CFLAGS LDFLAGS MOD_CFLAGS MOD_LDFLAGS
export LIBS RADIUS_LIB
export LEX LEX_FLAGS YACC YACC_FLAGS
export PREFIX LOCALBASE SYSBASE
# export relevant variables for recursive calls of this makefile
# (e.g. make deb)
#export LIBS
#export TAR
export NAME RELEASE OS ARCH
export cfg_prefix cfg_dir bin_prefix bin_dir modules_prefix modules_dir
export doc_prefix doc_dir man_prefix man_dir ut_prefix ut_dir lib_dir
export cfg_target modules_target data_dir data_prefix data_target
export INSTALL INSTALL_CFG INSTALL_BIN INSTALL_MODULES INSTALL_DOC INSTALL_MAN
export INSTALL_TOUCH

# extra excludes for tar
tar_extra_args+=

# include the common rules
include Makefile.rules

#extra targets
include Makefile.test

ifdef UNIT_TESTS
$(NAME): $(extra_objs) gen_misclibs # static_modules
else
$(NAME): $(extra_objs) # static_modules
endif

lex.yy.c: cfg.lex cfg.tab.h $(ALLDEP)
ifeq (,$(FASTER))
	@echo "Generating lexer"
endif
	$(Q)$(LEX) $(LEX_FLAGS) $<

cfg.tab.c cfg.tab.h: cfg.y $(ALLDEP)
ifeq (,$(FASTER))
	@echo "Generating parser"
endif
	$(Q)$(YACC) $(YACC_FLAGS) $<

.PHONY: all
all: $(NAME) modules utils


.PHONY: app
app: $(NAME)


.PHONY: _modules
_modules: $(modules)

.PHONY: $(modules)
$(modules):
	@$(MAKE) --no-print-directory -C $@ && \
		echo "Building $(notdir $@) module succeeded" || (\
			status=$$?; \
			echo "ERROR: Building $(notdir $@) module failed!"; \
			exit $$status; \
		)

.PHONY: modules
modules: $(deps_gen) gen_misclibs
ifeq (,$(FASTER))
	@set -e; \
	for r in $(modules); do \
		if [ -n "$$r" ]; then \
			if [ -d "$$r" ]; then \
				echo  "" ; \
				echo  "" ; \
				$(MAKE) -j -C $$r ; \
			fi ; \
		fi ; \
	done
else
	@$(MAKE) _modules || ( \
		status=$$?; \
		if echo $(MAKEFLAGS) | grep -q -- --jobserver; then \
			printf '\nBuilding one or more modules failed!\n'; \
			printf 'Please re-run make without -j / --jobs to find out which.\n\n'; \
		fi; \
		exit $$status \
	)
endif

gen_misclibs:
	@set -e; \
	for r in $(all_misclibs); do \
		echo  "" ; \
		echo  "" ; \
		$(MAKE) -j -C $$r ; \
	done

.PHONY: tool-docbook2pdf
tool-docbook2pdf:
	@if [ -z "$(DBXML2PDF)" ]; then \
		echo "error: docbook2pdf not found"; exit 1; \
	fi

.PHONY: tool-lynx
tool-lynx:
	@if [ -z "$(DBHTML2TXT)" ]; then \
		echo "error: lynx not found"; exit 1; \
	fi

.PHONY: tool-xsltproc
tool-xsltproc:
	@if [ -z "$(DBXML2HTML)" ]; then \
		echo "error: xsltproc not found"; exit 1; \
	fi
	@if [ -z "$(DBHTMLXSL)" ]; then \
		echo "error: docbook.xsl not found (docbook-xsl)"; exit 1; \
	fi

.PHONY: git-dir
git-dir:
	@if [ ! -r .git ]; then \
		echo "error: Not a git repo! (.git dir not found)"; exit 1; \
	fi

.PHONY: modules-contrib
modules-contrib: git-dir
	@set -e; ./doc/build-contrib.sh $(modules)

.PHONY: modules-readme
modules-readme: tool-lynx tool-xsltproc
	@set -e; \
	for mod in $(doc_modules); do \
		r=`basename $$mod`;\
		echo "Reading directory $$mod for module $$r";\
		if [ ! -d "$$mod/doc" ]; then \
			continue; \
		fi; \
		cd "$$mod/doc"; \
		if [ -f "$$r".xml ]; then \
			echo "docbook xml to html: $$r.xml"; \
			$(DBXML2HTML) -o $$r.html $(DBXML2HTMLPARAMS) $(DBHTMLXSL) \
						$$r.xml; \
			echo "docbook html to txt: $$r.html"; \
			$(DBHTML2TXT) $(DBHTML2TXTPARAMS) $$r.html >$$r.txt; \
			echo "docbook txt to readme: $$r.txt"; \
			rm $$r.html; \
			mv $$r.txt ../README; \
			echo ""; \
		fi; \
		cd ../../..; \
	done

.PHONY: modules-docbook-txt
modules-docbook-txt: tool-lynx tool-xsltproc
	@set -e; \
	for mod in $(doc_modules); do \
		r=`basename $$mod`;\
		echo "Reading directory $$mod for module $$r";\
		if [ ! -d "$$mod/doc" ]; then \
			continue; \
		fi; \
		cd "$$mod/doc"; \
		if [ -f "$$r".xml ]; then \
			echo ""; \
			echo "docbook xml to html: $$r.xml"; \
			$(DBXML2HTML) -o $$r.html $(DBXML2HTMLPARAMS) $(DBHTMLXSL) \
						$$r.xml; \
			echo "docbook html to txt: $$r.html"; \
			$(DBHTML2TXT) $(DBHTML2TXTPARAMS) $$r.html >$$r.txt; \
			rm $$r.html; \
			echo ""; \
		fi; \
		cd ../../..; \
	done

.PHONY: modules-docbook-html
modules-docbook-html: tool-xsltproc
	@set -e; \
	for mod in $(doc_modules); do \
		r=`basename $$mod`;\
		echo "Reading directory $$mod for module $$r";\
		if [ ! -d "$$mod/doc" ]; then \
			continue; \
		fi; \
		cd "$$mod/doc"; \
		if [ -f "$$r".xml ]; then \
			echo ""; \
			echo "docbook xml to html: $$r.xml"; \
			$(DBXML2HTML) -o $$r.html $(DBXML2HTMLPARAMS) $(DBHTMLXSL) \
						$$r.xml; \
			echo ""; \
		fi; \
		cd ../../..; \
	done

.PHONY: modules-docbook-pdf
modules-docbook-pdf: tool-docbook2pdf
	@set -e; \
	for mod in $(doc_modules); do \
		r=`basename $$mod`;\
		echo "Reading directory $$mod for module $$r";\
		if [ ! -d "$$mod/doc" ]; then \
			continue; \
		fi; \
		cd "$$mod/doc"; \
		if [ -f "$$r".xml ]; then \
			echo ""; \
			echo "docbook xml to pdf: $$r.xml"; \
			$(DBXML2PDF) "$$r".xml; \
		fi; \
		cd ../../..; \
	done

.PHONY: modules-docbook
modules-docbook: modules-docbook-txt modules-docbook-html modules-docbook-pdf

.PHONY: dbschema-docbook-txt
dbschema-docbook-txt: dbschema
	@set -e; \
	for r in $(wildcard doc/database/*.sgml) "" ; do \
		if [ -f "$$r" ]; then \
			echo  "" ; \
			echo  "docbook2txt $$r" ; \
			docbook2txt -o "doc/database/" "$$r" ; \
		fi ; \
	done

.PHONY: dbschema-docbook-html
dbschema-docbook-html: dbschema
	@set -e; \
	for r in $(wildcard doc/database/*.sgml) "" ; do \
		if [ -f "$$r" ]; then \
			echo  "" ; \
			echo  "docbook2html $$r" ; \
			docbook2html --nochunks -o "doc/database/" "$$r" ; \
		fi ; \
	done

.PHONY: dbschema-docbook-pdf
dbschema-docbook-pdf: dbschema
	@set -e; \
	for r in $(wildcard doc/database/*.sgml) "" ; do \
		if [ -f "$$r" ]; then \
			echo  "" ; \
			echo  "docbook2pdf $$r" ; \
			docbook2pdf -o "doc/database/" "$$r" ; \
		fi ; \
	done

.PHONY: dbschema-docbook
dbschema-docbook: dbschema-docbook-txt dbschema-docbook-html dbschema-docbook-pdf


$(extra_objs):
	-@echo "Extra objs: $(extra_objs)"
	@set -e; \
	for r in $(static_modules_path) "" ; do \
		if [ -n "$$r" ]; then \
			echo  "" ; \
			echo  "Making static module $r" ; \
			$(MAKE) -C $$r static ; \
		fi ; \
	done



dbg: $(NAME)
	gdb -command debug.gdb

.PHONY: tar
.PHONY: dist

dist: tar

tar: $(NEWREVISION)
	$(TAR) -C .. \
		--exclude=$(notdir $(CURDIR))/tmp* \
		--exclude=$(notdir $(CURDIR))/debian* \
		--exclude=.svn* \
		--exclude=.git \
		--exclude=.gitignore \
		--exclude=Makefile.conf \
		--exclude=*.[do] \
		--exclude=*.so \
		--exclude=*.il \
		--exclude=$(notdir $(CURDIR))/$(NAME) \
		--exclude=*.gz \
		--exclude=*.bz2 \
		--exclude=*.tar \
		--exclude=*.patch \
		--exclude=.\#* \
		--exclude=*.swp \
		--exclude=*~ \
		${tar_extra_args} \
		-cf - $(notdir $(CURDIR)) | \
			(mkdir -p tmp/_tar1; mkdir -p tmp/_tar2 ; \
			    cd tmp/_tar1; $(TAR) -xf - ) && \
			    mv tmp/_tar1/$(notdir $(CURDIR)) \
			       tmp/_tar2/"$(NAME)-$(RELEASE)" && \
			    (cd tmp/_tar2 && $(TAR) \
			                    -zcf ../../"$(NAME)-$(RELEASE)_src".tar.gz \
			                               "$(NAME)-$(RELEASE)" ) ; \
			    rm -rf tmp/_tar1; rm -rf tmp/_tar2

# binary dist. tar.gz
.PHONY: bin
bin:
	mkdir -p tmp/$(NAME)/usr/local
	$(MAKE) install basedir=tmp/$(NAME) prefix=/usr/local
	$(TAR) -C tmp/$(NAME)/ -zcf ../$(NAME)-$(RELEASE)_$(OS)_$(ARCH).tar.gz .
	rm -rf tmp/$(NAME)

.PHONY: deb-orig-tar
deb-orig-tar: tar
	mv "$(NAME)-$(RELEASE)_src".tar.gz ../$(NAME)_$(RELEASE:-dev=).orig.tar.gz

.PHONY: deb
deb:
	rm -rf debian
	# dpkg-source cannot use links for debian source
	cp -r packaging/debian debian
	dpkg-buildpackage \
		-I.git -I.gitignore \
		-I*.swp -I*~ \
		-i\\.git\|debian\|^\\.\\w+\\.swp\|lex\\.yy\\.c\|cfg\\.tab\\.\(c\|h\)\|\\w+\\.patch \

=== db/example/Makefile ===
#
# database example module makefile
#
# 
# WARNING: do not run this directly, it should be run by the master Makefile

auto_gen=
NAME=dbexample.so
LIBS=

include ../../Makefile.modules

=== db/schema/Makefile ===

# OpenSIPS database descriptions for modules
TABLES := $(patsubst opensips-%.xml,%,$(wildcard opensips-*.xml))

ROOT=../..
STYLESHEETS=$(ROOT)/doc/dbschema/xsl

# Stylesheet used to generate db_table nodes for pi_framework XML schema
PI_FRAMEWORK_TABLE_XSL = $(STYLESHEETS)/pi_framework_table.xsl

# Stylesheet used to generate mod nodes for pi_framework XML schema
PI_FRAMEWORK_MOD_XSL = $(STYLESHEETS)/pi_framework_mod.xsl

# Stylesheet used to generate MySQL database schema
MYSQL_XSL = $(STYLESHEETS)/mysql.xsl

# Stylesheet used to generate Postgres database schema
POSTGRES_XSL = $(STYLESHEETS)/postgres.xsl

# Stylesheet used to generate dbtext database schema
DBTEXT_XSL = $(STYLESHEETS)/dbtext.xsl

# Stylesheet used to generate berkeley database schema
DB_BERKELEY_XSL = $(STYLESHEETS)/db_berkeley.xsl

# Stylesheet used to generate oracle database schema
ORACLE_XSL = $(STYLESHEETS)/oracle.xsl

#Stylesheet used to generate sqlite database schema
SQLITE_XSL = $(STYLESHEETS)/sqlite.xsl

# Stylesheet used to generate docbook documentation
DOCBOOK_XSL = $(STYLESHEETS)/docbook.xsl


# Enable/disable DTD validation
VALIDATE = 0

# Enable/disable verbose output (and DTD validation)
VERBOSE = 0

# XML Catalog used to resolve entities
CATALOG = $(ROOT)/doc/dbschema/catalog.xml

XSLTPROC = /usr/bin/xsltproc
XSLTPROC_FLAGS = --xinclude

ifeq ($(VALIDATE), 0)
	override XSLTPROC := $(XSLTPROC) --novalid
endif

ifeq ($(VERBOSE), 1)
	override XSLTPROC := $(XSLTPROC) --verbose
endif

all: mysql postgres dbtext db_berkeley docbook oracle pi_framework sqlite

.PHONY: pi_framework pi_framework_clean
pi_framework:
	for FILE in $(TABLES); do \
		XML_CATALOG_FILES=$(CATALOG) $(XSLTPROC) $(XSLTPROC_FLAGS) \
		--stringparam dir "$(ROOT)/scripts/pi_http" \
		--stringparam prefix "$$FILE-" \
		$(PI_FRAMEWORK_TABLE_XSL) opensips-"$$FILE".xml ; \
	done
	for FILE in $(TABLES); do \
		XML_CATALOG_FILES=$(CATALOG) $(XSLTPROC) $(XSLTPROC_FLAGS) \
		--stringparam dir "$(ROOT)/scripts/pi_http" \
		--stringparam prefix "$$FILE-" \
		$(PI_FRAMEWORK_MOD_XSL) opensips-"$$FILE".xml ; \
	done
	cat $(ROOT)/scripts/pi_http/pi_framework-00 \
		$(ROOT)/scripts/pi_http/*-table \
		$(ROOT)/scripts/pi_http/pi_framework-01 \
		$(ROOT)/scripts/pi_http/*-mod \
		$(ROOT)/scripts/pi_http/pi_framework-02 > \
		$(ROOT)/scripts/pi_http/pi_framework.xml

pi_framework_clean:
	-@rm -f $(ROOT)/scripts/pi_http/*-table
	-@rm -f $(ROOT)/scripts/pi_http/*-mod

.PHONY: mysql mysql_clean
mysql:
	for FILE in $(TABLES); do \
		XML_CATALOG_FILES=$(CATALOG) $(XSLTPROC) $(XSLTPROC_FLAGS) \
		--stringparam dir "$(ROOT)/scripts/mysql" \
		--stringparam prefix "$$FILE-" \
		--stringparam db "mysql" \
		$(MYSQL_XSL) opensips-"$$FILE".xml ; \
	done

mysql_clean:
	-@rm -f $(ROOT)/scripts/mysql/*

.PHONY: sqlite sqlite_clean
sqlite:
	for FILE in $(TABLES); do \
		XML_CATALOG_FILES=$(CATALOG) $(XSLTPROC) $(XSLTPROC_FLAGS) \
		--stringparam dir "$(ROOT)/scripts/sqlite" \
		--stringparam prefix "$$FILE-" \
		--stringparam db "sqlite" \
		$(SQLITE_XSL) opensips-"$$FILE".xml ; \
	done

sqlite_clean:
	-@rm -f $(ROOT)/scripts/sqlite/*



.PHONY: postgres postgres_clean
postgres:
	for FILE in $(TABLES); do \
		XML_CATALOG_FILES=$(CATALOG) $(XSLTPROC) $(XSLTPROC_FLAGS) \
		--stringparam dir "$(ROOT)/scripts/postgres" \
		--stringparam prefix "$$FILE-" \
		--stringparam db "postgres" \
		$(POSTGRES_XSL) opensips-"$$FILE".xml ; \
	done

postgres_clean:
	-@rm -f $(ROOT)/scripts/postgres/*

.PHONY: oracle oracle_clean
oracle:
	for FILE in $(TABLES); do \
		XML_CATALOG_FILES=$(CATALOG) $(XSLTPROC) $(XSLTPROC_FLAGS) \
		--stringparam dir "$(ROOT)/scripts/oracle" \
		--stringparam prefix "$$FILE-" \
		--stringparam db "oracle" \
		$(ORACLE_XSL) opensips-"$$FILE".xml ; \
	done

oracle_clean:
	-@rm -f $(ROOT)/scripts/oracle/*.sql

.PHONY: dbtext dbtext_clean
dbtext:
	for FILE in $(TABLES); do \
		XML_CATALOG_FILES=$(CATALOG) $(XSLTPROC) $(XSLTPROC_FLAGS) \
		--stringparam dir "$(ROOT)/scripts/dbtext/opensips" \
		--stringparam prefix "" \
		--stringparam db "dbtext" \
		$(DBTEXT_XSL) opensips-"$$FILE".xml ; \
	done
	set -e; \
	TMPFILE=`mktemp -t opensips-test.XXXXXXXXXX`; \
	for FILE in  $(sort $(wildcard $(ROOT)/scripts/dbtext/opensips/*)) ; do \
		if [ -f "$$FILE" ]; then \
			if [  "$$FILE" != "$(ROOT)/scripts/dbtext/opensips/version" -a \
					`wc -l "$$FILE" | cut -f 1 -d ' '` -gt 1 ]; then \
				tail -1 "$$FILE" >> "$(ROOT)/scripts/dbtext/opensips/version" ; \
 				head -n 1 "$$FILE" > "$$TMPFILE" ; \
				cp "$$TMPFILE" "$$FILE" ; \
			fi ; \
		fi ; \
	done ; \
	rm -f "$$TMPFILE"

dbtext_clean:
	-@rm -f $(ROOT)/scripts/dbtext/opensips/*

.PHONY: db_berkeley db_berkeley_clean
db_berkeley:
	for FILE in $(TABLES); do \
		XML_CATALOG_FILES=$(CATALOG) $(XSLTPROC) $(XSLTPROC_FLAGS) \
		--stringparam dir "$(ROOT)/scripts/db_berkeley/opensips" \
		--stringparam prefix "" \
		--stringparam db "db_berkeley" \
		$(DB_BERKELEY_XSL) opensips-"$$FILE".xml ; \
	done
	set -e; \
	TMPFILE=`mktemp -t opensips-test.XXXXXXXXXX`; \
	for FILE in  $(sort $(wildcard $(ROOT)/scripts/db_berkeley/opensips/*)) ; do \
		if [ -f "$$FILE" ]; then \
			if [  "$$FILE" != "$(ROOT)/scripts/db_berkeley/opensips/version" ]; then \
				tail -2 "$$FILE" >> "$(ROOT)/scripts/db_berkeley/opensips/version" ; \
 				head -n 10 "$$FILE" > "$$TMPFILE" ; \
				cp "$$TMPFILE" "$$FILE" ; \
			fi ; \
		fi ; \
	done ; \
	rm -f "$$TMPFILE"

db_berkeley_clean:
	-@rm -f $(ROOT)/scripts/db_berkeley/opensips/*


.PHONY: docbook docbook_clean
docbook:
	for FILE in $(TABLES); do \
		XML_CATALOG_FILES=$(CATALOG) $(XSLTPROC) $(XSLTPROC_FLAGS) \
		--stringparam dir "$(ROOT)/doc/database" \
		--stringparam prefix "$$FILE-" \
		$(DOCBOOK_XSL) opensips-"$$FILE".xml ; \
	done ; \

	# link all documents to one file, to get nicer output
	echo "<!DOCTYPE book PUBLIC \"-//OASIS//DTD DocBook V4.4//EN\" \"http://www.oasis-open.org/docbook/sgml/4.4/docbook.dtd\"[" > "$(ROOT)/doc/database/tables.sgml"
	
	# create entities, as xi:include is not available in sgml docbook
	# substitute '-' for '_', docbook smgl don't like this
	for FILE in $(wildcard $(ROOT)/doc/database/*.xml); do \
		echo "  <!ENTITY `basename "$$FILE" | sed -e 's#_#-#g'` SYSTEM \""$$FILE"\">" >> "$(ROOT)/doc/database/tables.sgml" ; \
	done ; \
	#Include general documentation entities
	echo "  <!ENTITY % docentities SYSTEM \"../entities.xml\"> %docentities;" >> "$(ROOT)/doc/database/tables.sgml" ; \
	echo "]>" >> "$(ROOT)/doc/database/tables.sgml"
	# add bookinfo
	cat "$(ROOT)/doc/dbschema/bookinfo.xml" >> "$(ROOT)/doc/database/tables.sgml"
	# actually include the entities
	for FILE in $(wildcard $(ROOT)/doc/database/*.xml); do \
		echo "    &`basename "$$FILE" | sed -e 's#_#-#g'`" >> "$(ROOT)/doc/database/tables.sgml" ; \
	done ; \
	echo "</book>" >> "$(ROOT)/doc/database/tables.sgml"

docbook_clean:
	-@rm -f $(ROOT)/doc/database/*.xml
	-@rm -f $(ROOT)/doc/database/tables.sgml


.PHONY: clean
clean: mysql_clean postgres_clean oracle_clean dbtext_clean db_berkeley_clean docbook_clean pi_framework_clean

=== lib/digest_auth/Makefile ===
LIBNAME=	digest_auth

include ../../Makefile.openssl

LIBS=

CPP_CMD?=cpp

SHA_256_SUPPORT:= $(shell bash -c "echo -e '\x23define SHA256_Init(x) \
	_TEST_P_A_S_S_E_D_()\n\x23include <openssl/sha.h>\n'" \
	| $(CPP_CMD) $(DEFS) 2>/dev/null | grep -q _TEST_P_A_S_S_E_D_ && echo yes)

SHA_512_256_SUPPORT:= $(shell bash -c "echo -e '\x23define EVP_sha512_256(x) \
	_TEST_P_A_S_S_E_D_()\n\x23include <openssl/evp.h>\n'" \
	| $(CPP_CMD) $(DEFS) 2>/dev/null | grep -q _TEST_P_A_S_S_E_D_ && echo yes)


ifeq ($(SHA_256_SUPPORT)$(SHA_256_SUPPORT_DISABLE),yes)
	DEFS+=-DSHA_256_ENABLE
else
	exclude_files+=$(wildcard *sha256.c)
endif

ifeq ($(SHA_512_256_SUPPORT)$(SHA_512_256_SUPPORT_DISABLE),yes)
	DEFS+=-DSHA_512_256_ENABLE
else
	exclude_files+=$(wildcard *sha512t256.c)
endif

include ../../Makefile.misclibs

=== lib/reg/Makefile ===
LIBNAME=	reg

include ../../Makefile.misclibs

=== modules/aaa_diameter/Makefile ===
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen =
NAME = aaa_diameter.so
LIBS += -lfdproto -lfdcore
extra_sources = app_opensips/avps.c

include ../../Makefile.modules

=== modules/aaa_radius/Makefile ===
#
# radius module makefile
#
# 
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=aaa_radius.so

ETC_DIR?=../../etc/

# Find the radius library we shall use
#
ifeq ($(RADIUSCLIENT),)
RADIUSCLIENT=$(shell if [ -n "`ldconfig -p | grep radcli`" ]; then echo "RADCLI"; \
	elif [ -n "`ldconfig -p | grep freeradius`" ]; then echo "FREERADIUS"; \
	elif [ -n "`ldconfig -p | grep radiusclient-ng`" ];then echo "RADIUSCLIENT"; fi)
endif


ifneq ($(RADIUSCLIENT), RADCLI)
ifneq ($(RADIUSCLIENT), FREERADIUS)
ifeq ($(RADIUSCLIENT), RADIUSCLIENT)
	DEFS+= -DRADIUSCLIENT
	RADIUS_LIB=-lradiusclient-ng
	RADIUS_PACKET=libradiusclient-ng-dev
endif
else
	DEFS+= -DFREERADIUS
	RADIUS_LIB=-lfreeradius-client
	RADIUS_PACKET=libfreeradius-client2
endif
else
	DEFS+= -DRADCLI
	RADIUS_LIB=-lradcli
	RADIUS_PACKET=libradcli
endif

ifeq ($(CROSS_COMPILE),)
	BUILDER=$(shell if pkg-config --exists $(RADIUS_PACKET); then \
		echo "pkg-config $(RADIUS_PACKET)"; \
	fi)
else
	DEFS+=-I$(LOCALBASE)/include
	LIBS+=-L$(LOCALBASE)/lib $(RADIUS_LIB)
endif

ifneq ($(BUILDER),)
	DEFS+= $(shell $(BULDER) --cflags)
	LIBS+= $(shell $(BULDER) --libs)
else
ifeq ($(CROSS_COMPILE),)
	## we didn't find the packet with pkg-config
	## last chance try it without knowing lib path
	LIBS+= $(RADIUS_LIB)
endif
endif


# Comment the next two line and uncomment the following two if you want
# to enable Radius support

include ../../Makefile.modules

install_module_custom: $(cfg_prefix)/$(cfg_dir)
	$(INSTALL_TOUCH) \
		$(cfg_prefix)/$(cfg_dir)/dictionary.opensips.sample ; \
	$(INSTALL_CFG) $(ETC_DIR)/dictionary.opensips \
		$(cfg_prefix)/$(cfg_dir)/dictionary.opensips.sample ; \
	if [ ! -f $(cfg_prefix)/$(cfg_dir)/dictionary.opensips ]; then \
		mv -f $(cfg_prefix)/$(cfg_dir)/dictionary.opensips.sample \
			$(cfg_prefix)/$(cfg_dir)/dictionary.opensips; \
	fi; \

=== modules/aka_av_diameter/Makefile ===
#
# AKA Authentication - AKA authentication Diameter support
#
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=aka_av_diameter.so
include ../../Makefile.modules

=== modules/alias_db/Makefile ===
# User aliases
#
# 
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs

auto_gen=
NAME=alias_db.so

include ../../Makefile.modules

=== modules/auth_aka/Makefile ===
#
# AKA Authentication - AKA authentication support
#
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=auth_aka.so
misclibs=../../lib/digest_auth/libdigest_auth.a
include ../../Makefile.modules

=== modules/auth_db/Makefile ===
# Digest Authentication - Database support
#
# 
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=auth_db.so

include ../../Makefile.modules

=== modules/auth_jwt/Makefile ===
# JWT Authentication
#
# 
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=auth_jwt.so
LIBS+=-ljwt

include ../../Makefile.modules
include ../../Makefile.openssl

=== packaging/debian/changelog ===
opensips (3.6.0-1) stable; urgency=low

  * Minor Public Release.

 -- Liviu Chircu <liviu@opensips.org>  Wed, 23 Jul 2025 16:04:18 +0300

opensips (3.6.0-beta-1) beta; urgency=low

  * Major Public Release.

 -- Liviu Chircu <liviu@opensips.org>  Wed, 21 May 2025 16:43:59 +0300

opensips (3.6.0-dev-1) beta; urgency=low

  * Development Build.

 -- Razvan Crainea <razvan@opensips.org>  Mon, 27 May 2024 16:00:00 +0300

opensips (3.5.0-dev-1) beta; urgency=low

  * Development Build.

 -- Nick Altmann <nick@altmann.pro>  Thu, 18 May 2023 16:00:00 +0300

opensips (3.4.0-1) beta; urgency=low

  * Major Public Release.

 -- Liviu Chircu <liviu@opensips.org>  Wed, 17 May 2023 16:06:38 +0300

opensips (3.3.0-1) stable; urgency=low

  * Minor Public Release.

 -- Razvan Crainea <razvan@opensips.org>  Mon, 17 Aug 2021 00:00:00 +0300

opensips (3.2.0-1) stable; urgency=low

  * Minor Public Release.

 -- Razvan Crainea <razvan@opensips.org>  Wed, 21 Jul 2021 15:07:53 +0300

opensips (3.1.0-1) stable; urgency=low

  * Minor Public Release.

 -- Razvan Crainea <razvan@opensips.org>  Tue, 16 Apr 2019 21:15:04 +0300

opensips (3.0.0-1) unstable; urgency=medium

  * Local package

 -- Razvan Crainea <razvan@opensips.org>  Fri, 14 Apr 2017 12:20:44 +0200

=== PKGBUILD ===
# Maintainer: Sergej Pupykin <pupykin.s+arch@gmail.com>

pkgname=opensips
pkgver=3.6.0
pkgrel=1
pkgdesc="An Open Source SIP Server able to act as a SIP proxy, registrar, location server, redirect server ..."
url="https://www.opensips.org"
depends=('gcc-libs')
makedepends=('libldap' 'libmariadbclient' 'libmicrohttpd' 'libxml2' 'libxslt'
             'lynx' 'openssl' 'postgresql-libs' 'unixodbc')
optdepends=('curl: db_http module'
            'libldap: ldap module'
            'libmicrohttpd: httpd module'
            'libxml2: presence module'
            'mariadb-libs: db_mysql module'
            'openssl: tls_openssl module'
            'postgresql-libs'
            'unixodbc: db_unixodbc module')
backup=("etc/opensips/opensips.cfg"
	"etc/opensips/osipsconsolerc"
	"etc/opensips/opensipsctlrc")
arch=('x86_64')
license=('GPL')
options=('!emptydirs' '!makeflags')
source=(https://opensips.org/pub/opensips/${pkgver}/opensips-${pkgver}.tar.gz
	opensips.service)
sha256sums=('9841d6ff36c25ce0445dd49b6129e7020944e56d4fb0e5368bc5f734403a0c31'
            'c2fec4be085b108db10834fa9832e98d696c2de6408f85f96cf89c13bf6be819')

_modules="db_http db_mysql db_postgres db_unixodbc h350 httpd ldap presence presence_xml proto_tls tls_mgm tls_openssl tm rr"

build() {
  cd "$srcdir"/$pkgname-$pkgver/

  make \
	include_modules="${_modules}" bin_dir=bin/ cfg_target=/etc/$pkgname/ \
	LIBDIR=lib PREFIX=/usr
}

package() {
  cd "$srcdir"/$pkgname-$pkgver/

  make \
	include_modules="${_modules}" bin_dir=bin/ cfg_target=/etc/$pkgname/ cfg_prefix="$pkgdir" \
	BASEDIR="$pkgdir" PREFIX=/usr LIBDIR=lib install

  install -Dm0644 "$srcdir"/$pkgname.service "$pkgdir"/usr/lib/systemd/system/$pkgname.service
}

=== packaging/debian/control ===
Source: opensips
Section: net
Priority: optional
Maintainer: Răzvan Crainea <razvan@opensips.org>
Build-Depends: bison,
               debhelper (>= 10),
               default-libmysqlclient-dev | libmysqlclient-dev,
               debhelper (>= 9.20160709) | dh-systemd (>= 1.5),
               dpkg-dev (>= 1.16.1.1),
               flex,
               libconfuse-dev,
               libcurl4-gnutls-dev,
               libdb-dev (>= 4.6.19),
               libfdcore6 (>= 1.2.1) | base-files,
               libfdproto6 (>= 1.2.1) | base-files,
               libfreediameter-dev (>= 1.2.1) | base-files,
               libexpat1-dev,
               libmaxminddb-dev | libgeoip-dev (>= 1.4.4),
               libhiredis-dev,
               libjson-c-dev,
               libjwt-dev | base-files,
               librdkafka-dev,
               libldap2-dev,
               liblua5.1-0-dev,
               libmemcached-dev,
               libmicrohttpd-dev,
               libmnl-dev,
               libjwt-dev | base-files,
               libbson-dev | base-files,
               libmongoc-dev | base-files,
               libncurses5-dev,
               libpcre3-dev,
               libperl-dev,
               libpq-dev,
               librabbitmq-dev,
               libradcli-dev | libfreeradius-client-dev,
               libsctp-dev [linux-any],
               libsnmp-dev,
               libsqlite3-dev,
               libssl-dev,
               lsb-release,
               uuid-dev,
               libxml2-dev,
               pkg-config,
               python | python-is-python3,
               python-dev | python-dev-is-python3,
               unixodbc-dev,
               xsltproc,
               zlib1g-dev
Standards-Version: 3.9.8
Homepage: https://opensips.org/

Package: opensips
Architecture: any
Multi-Arch: foreign
Depends: adduser, python | python-is-python3, ${misc:Depends}, ${shlibs:Depends}
Suggests: opensips-auth-jwt-module,
          opensips-auth-modules,
          opensips-berkeley-module,
          opensips-carrierroute-module,
          opensips-cgrates-module,
          opensips-compression-module,
          opensips-cpl-module,
          opensips-dbhttp-module,
          opensips-dialplan-module,
          opensips-diameter-module,
          opensips-emergency-module,
          opensips-geoip-module,
          opensips-http-modules,
          opensips-identity-module,
          opensips-ipsec-module,
          opensips-jabber-module,
          opensips-json-module,
          opensips-kafka-module,
          opensips-ldap-modules,
          opensips-lua-module,
          opensips-memcached-module,
          opensips-mongodb-module,
          opensips-msrp-modules,
          opensips-mysql-module,
          opensips-perl-modules,
          opensips-postgres-module,
          opensips-presence-modules,
          opensips-prometheus-module,
          opensips-python-module,
          opensips-rabbitmq-modules,
          opensips-radius-modules,
          opensips-redis-module,
          opensips-regex-module,
          opensips-restclient-module,
          opensips-sctp-module [linux-any],
          opensips-siprec-module,
          opensips-snmpstats-module,
          opensips-sqlite-module,
          opensips-stir-shaken-module,
          opensips-tls-module,
          opensips-tls-openssl-module,
          opensips-tls-wolfssl-module,
          opensips-tlsmgm-module,
          opensips-unixodbc-module,
          opensips-uuid-module,
          opensips-wss-module,
          opensips-xml-module,
          opensips-xmlrpc-module,
          opensips-xmpp-module
Description: very fast and configurable SIP server
 OpenSIPS is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, OpenSIPS can handle thousands calls
 per second even on low-budget hardware.
 .
 C Shell-like scripting language provides full control over the server's
 behaviour. Its modular architecture allows only required functionality to be
 loaded.
 .
 Among others, the following modules are available: Digest Authentication, CPL
 scripts, Instant Messaging, MySQL support, Presence Agent, Radius
 Authentication, Record Routing, SMS Gateway, Jabber/XMPP Gateway, Transaction
 Module, Registrar and User Location, Load Balaning/Dispatching/LCR,
 XMLRPC Interface.
 .
 This package contains the main OpenSIPS binary along with the principal modules
 and support binaries including opensipsmc configuration tool.

Package: opensips-auth-jwt-module
Architecture: any
Multi-Arch: same
Depends: opensips (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: JSON Web Tokens authentication module for OpenSIPS
 OpenSIPS is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, OpenSIPS can handle thousands calls
 per second even on low-budget hardware.
 .
 The module implements authentication over JSON Web Tokens. In
 some cases ( ie. WebRTC ) the user authenticates on another
 layer ( other than SIP ), so it makes no sense to
 double-authenticate it on the SIP layer. Thus, the SIP client
 will simply present the JWT auth token it received from the
 server, and pass it on to OpenSIPS which will use that for
 authentication purposes. It relies on two DB tables, one
 containing JWT profiles ( a profile name and it's SIP username
 associated to it ) and one containing JWT secrets. Each secret
 has a corresponding profile, the KEY used for signing the JWT
 and two timestamps describing a validation interval. Multiple
 JWT secrets can point to the same JWT profile.

Package: opensips-auth-modules
Architecture: any
Multi-Arch: same
Depends: opensips (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Authentication interfaces for OpenSIPS
 OpenSIPS is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, OpenSIPS can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the modules that are being used to provide
 SIP authentication in OpenSIPS. It consists of both the
 authentication interface (the auth module), as well as the UAC
 authentication module (uac_auth).

Package: opensips-berkeley-bin
Architecture: any
Multi-Arch: foreign
Depends: opensips (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: opensips-berkeley-module, opensips-berkeley-schema
Description: Berkeley Database module for OpenSIPS - helper program
 OpenSIPS is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, OpenSIPS can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the berkeley database module for OpenSIPS, a
 high-performance embedded DB kernel. You should normally install
 opensips-berkeley-module and not this package directly.

Package: opensips-berkeley-module
Architecture: any
Multi-Arch: same
Depends: db-util (>= 4.6.19),
         opensips (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: opensips-berkeley-bin, opensips-berkeley-schema
Description: Berkeley Database module for OpenSIPS
 OpenSIPS is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, OpenSIPS can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the berkeley database module for OpenSIPS, a
 high-performance embedded DB kernel. All database tables are stored
 in files, no additional server is necessary.

Package: opensips-berkeley-dbschema
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: opensips-berkeley-bin, opensips-berkeley-module
Description: Berkeley database schema for OpenSIPS
 OpenSIPS is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, OpenSIPS can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the Berkeley database schema files for OpenSIPS.

Package: opensips-carrierroute-module
Architecture: any
Multi-Arch: same
Depends: opensips (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Carrierroute module for OpenSIPS
 OpenSIPS is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, OpenSIPS can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the carrierroute module for OpenSIPS, an integrated
 solution for routing, balancing and blacklisting.

Package: opensips-cgrates-module
Architecture: any
Multi-Arch: same
Depends: opensips (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: CGRateS connector for OpenSIPS
 OpenSIPS is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, OpenSIPS can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides a connnector to the CGRateS rating/billing engine.

Package: opensips-compression-module
Architecture: any
Multi-Arch: same
Depends: opensips (= ${binary:Version}),
         zlib1g,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Headers and body compression module for OpenSIPS
 OpenSIPS is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, OpenSIPS can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the compression module, that is able to compress
 SIP headers and body, as  well as shrink the size of a SIP package.

Package: opensips-cpl-module
Architecture: any
Multi-Arch: same
Depends: opensips (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: CPL module (CPL interpreter engine) for OpenSIPS
 OpenSIPS is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, OpenSIPS can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides a CPL (Call Processing Language) interpreter for
 OpenSIPS, turning OpenSIPS into a CPL server (storage and interpreter).

Package: opensips-dbg
Architecture: any
Multi-Arch: same
Section: debug
Depends: opensips (= ${binary:Version}), ${misc:Depends}
Description: very fast and configurable SIP server [debug symbols]
 OpenSIPS is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, OpenSIPS can handle thousands calls
 per second even on low-budget hardware.
 .
 This package contains the debugging symbols for the OpenSIPS binaries and
 modules. You only need to install it if you need to debug OpenSIPS.

Package: opensips-dbhttp-module
Architecture: any
Multi-Arch: same
Depends: opensips (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: HTTP database connectivity module for OpenSIPS
 OpenSIPS is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, OpenSIPS can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the HTTP-based database driver for OpenSIPS

Package: opensips-dialplan-module
Architecture: any
Multi-Arch: same
Depends: opensips (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Generic string translation module for OpenSIPS
 OpenSIPS is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, OpenSIPS can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides dialplan module that implements generic string
 translations based on matching and replacement rules. It can be used to
 manipulate R-URI or a PV and to translated to a new format/value.

Package: opensips-diameter-module
Architecture: any
Multi-Arch: same
Depends: opensips (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Diameter module for OpenSIPS
 OpenSIPS is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, OpenSIPS can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides a DIAMETER driver for the AAA API from OpenSIPS.

Package: opensips-emergency-module
Architecture: any
Multi-Arch: same

=== packaging/debian/rules ===
#!/usr/bin/make -f
# 2010/08/24: Allow building of individual modules (kennard)
# 2015/08/14: Change URL to github sources

# To control which packages get built, set BUILD_MODPKG_LIST to list
# of packages to build (see ALL_MODPKG_LIST for candiate names).  Set to
# 'NONE' to not build any module packages (the primary package is always
# built). By default all delcared packages (debian/control) will be built.


# Supported DEB_BUILD_OPTIONS:
#	noopt,nostrip,debug -- standard
#	upstreamcflags -- don't set cflags, let upstream package Makefile do it

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEBVERSION:=$(shell head -n 1 debian/changelog \
                    | sed -e 's/^[^(]*(\([^)]*\)).*/\1/')
UPVERSION:=$(shell echo $(DEBVERSION) \
					| sed -e 's/^.*://' -e 's/-[0-9.]*$$//' -e 's/.dfsg$$//')

FILENAME := opensips_$(UPVERSION).orig.tar.gz
URL := https://github.com/OpenSIPS/opensips/archive/$(UPVERSION).tar.gz

#
# INSTALL_PREFIX - can be defined at build time to force a specific install
#                  path for both binaries and config files
#
# We automatically disable "dh_usrlocal" if the user intends the package to
# install files under "/usr/local" (this should be a user-only directory!)
ifneq ($(INSTALL_PREFIX),)
OVERRIDE_DH_USRLOCAL := $(shell echo $(INSTALL_PREFIX) | \
                          grep -c "^/\+usr/local\>")

ifneq ($(OVERRIDE_DH_USRLOCAL),0)
override_dh_usrlocal:
endif

BIN_PREFIX ?= $(INSTALL_PREFIX)
else
BIN_PREFIX ?= /usr
endif

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# List of all debian module packages we will build
# Used to index the make variable below, which has details about each package
ALL_MODPKG_LIST := \
	AUTH BERKELEY CARRIERROUTE CGRATES COMPRESSION CPL \
	DBHTTP DIALPLAN EMERGENCY GEOIP HTTP IDENTITY JABBER \
	JSON KAFKA LDAP LUA MEMCACHED MSRP MYSQL PERL POSTGRES \
	PRESENCE PROMETHEUS PROTO_TLS PROTO_WSS PYTHON RABBITMQ \
	REDIS RADIUS REGEX REST_CLIENT SIPREC SNMPSTATS SQLITE STIR_SHAKEN \
	TLS_MGM TLS_OPENSSL TLS_WOLFSSL UNIXODBC UUID XML XMLRPC XMPP IPSEC


MAJOR_RELEASE=$(shell lsb_release -rs | cut -d "." -f 1)
# debian unstable (sid) doesn't output a version number, so emulate one
ifeq ($(MAJOR_RELEASE), unstable)
	MAJOR_RELEASE=1000
endif

ifeq ($(shell dpkg-vendor --derives-from Debian && echo yes),yes)
	REL_STRETCH_OR_XENIAL=9
endif
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	REL_STRETCH_OR_XENIAL=16
endif

ifeq ($(shell dpkg-vendor --derives-from Debian && echo yes),yes)
	REL_BUSTER_OR_FOCAL=10
endif
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	REL_BUSTER_OR_FOCAL=20
endif


#
# AUTH_JWT package
#
ifeq ($(shell test $(MAJOR_RELEASE) -ge $(REL_BUSTER_OR_FOCAL); echo $$?),0)
	ALL_MODPKG_LIST += AUTH_JWT
endif


#
# DIAMETER package
#
ifeq ($(shell test $(MAJOR_RELEASE) -ge $(REL_BUSTER_OR_FOCAL); echo $$?),0)
	ALL_MODPKG_LIST += DIAMETER
endif


#
# MONGODB package
#
ifeq ($(shell test $(MAJOR_RELEASE) -ge $(REL_STRETCH_OR_XENIAL); echo $$?),0)
	ALL_MODPKG_LIST += MONGODB
endif


#
# PROTO_SCTP package
#
# add SCTP only on linux systems
ifeq ($(DEB_HOST_ARCH_OS),linux)
	ALL_MODPKG_LIST += PROTO_SCTP
endif


ifeq ($(BUILD_MODPKG_LIST),NONE)
	override BUILD_MODPKG_LIST :=
else
	ifeq ($(BUILD_MODPKG_LIST),)
		override BUILD_MODPKG_LIST := $(ALL_MODPKG_LIST)
	endif
endif


# FOO_MODULES is the directory name within modules/ that belongs to the package
# FOO_MOD_PATH is same as FOO_MODULES, but with 'modules/' prepended

AUTH_JWT_PKGNAME = opensips-auth-jwt-module
AUTH_JWT_MODULES = auth_jwt
AUTH_JWT_MOD_PATH=$(addprefix modules/, $(AUTH_JWT_MODULES))
AUTH_PKGNAME = opensips-auth-modules
AUTH_MODULES = auth auth_aka uac_auth
AUTH_MOD_PATH=$(addprefix modules/, $(AUTH_MODULES))
BERKELEY_PKGNAME = opensips-berkeley-module
BERKELEY_DBSCHEMA_PKGNAME = opensips-berkeley-dbschema
BERKELEY_MODULES = db_berkeley
BERKELEY_MOD_PATH=$(addprefix modules/, $(BERKELEY_MODULES))
CARRIERROUTE_PKGNAME = opensips-carrierroute-module
CARRIERROUTE_MODULES = carrierroute
CARRIERROUTE_MOD_PATH=$(addprefix modules/, $(CARRIERROUTE_MODULES))
CGRATES_PKGNAME = opensips-cgrates-module
CGRATES_MODULES = cgrates
CGRATES_MOD_PATH=$(addprefix modules/, $(CGRATES_MODULES))
COMPRESSION_PKGNAME = opensips-compression-module
COMPRESSION_MODULES = compression
COMPRESSION_MOD_PATH=$(addprefix modules/, $(COMPRESSION_MODULES))
CPL_PKGNAME = opensips-cpl-module
CPL_MODULES = cpl_c
CPL_MOD_PATH=$(addprefix modules/, $(CPL_MODULES))
DBHTTP_PKGNAME = opensips-dbhttp-module
DBHTTP_MODULES = db_http
DBHTTP_MOD_PATH=$(addprefix modules/, $(DBHTTP_MODULES))
DIALPLAN_PKGNAME = opensips-dialplan-module
DIALPLAN_MODULES = dialplan
DIALPLAN_MOD_PATH=$(addprefix modules/, $(DIALPLAN_MODULES))
DIAMETER_PKGNAME = opensips-diameter-module
DIAMETER_MODULES = aaa_diameter aka_av_diameter
DIAMETER_MOD_PATH=$(addprefix modules/, $(DIAMETER_MODULES))
EMERGENCY_PKGNAME = opensips-emergency-module
EMERGENCY_MODULES = emergency
EMERGENCY_MOD_PATH=$(addprefix modules/, $(EMERGENCY_MODULES))
GEOIP_PKGNAME = opensips-geoip-module
GEOIP_MODULES = mmgeoip
GEOIP_MOD_PATH=$(addprefix modules/, $(GEOIP_MODULES))
HTTP_PKGNAME = opensips-http-modules
HTTP_MODULES = httpd mi_html mi_http pi_http
HTTP_MOD_PATH=$(addprefix modules/, $(HTTP_MODULES))
IDENTITY_PKGNAME = opensips-identity-module
IDENTITY_MODULES = identity
IDENTITY_MOD_PATH=$(addprefix modules/, $(IDENTITY_MODULES))
JABBER_PKGNAME = opensips-jabber-module
JABBER_MODULES = jabber
JABBER_MOD_PATH=$(addprefix modules/, $(JABBER_MODULES))
JSON_PKGNAME = opensips-json-module
JSON_MODULES = json
JSON_MOD_PATH=$(addprefix modules/, $(JSON_MODULES))
KAFKA_PKGNAME = opensips-kafka-module
KAFKA_MODULES = event_kafka
KAFKA_MOD_PATH=$(addprefix modules/, $(KAFKA_MODULES))
LDAP_PKGNAME = opensips-ldap-modules
LDAP_MODULES = ldap h350
LDAP_MOD_PATH=$(addprefix modules/, $(LDAP_MODULES))
LUA_PKGNAME = opensips-lua-module
LUA_MODULES = lua
LUA_MOD_PATH=$(addprefix modules/, $(LUA_MODULES))
MEMCACHED_PKGNAME = opensips-memcached-module
MEMCACHED_MODULES = cachedb_memcached
MEMCACHED_MOD_PATH=$(addprefix modules/, $(MEMCACHED_MODULES))
MONGODB_PKGNAME = opensips-mongodb-module
MONGODB_MODULES = cachedb_mongodb
MONGODB_MOD_PATH=$(addprefix modules/, $(MONGODB_MODULES))
MSRP_PKGNAME = opensips-msrp-modules
MSRP_MODULES = msrp_gateway msrp_relay msrp_ua proto_msrp
MSRP_MOD_PATH=$(addprefix modules/, $(MSRP_MODULES))
MYSQL_PKGNAME = opensips-mysql-module
MYSQL_DBSCHEMA_PKGNAME = opensips-mysql-dbschema
MYSQL_MODULES = db_mysql
MYSQL_MOD_PATH=$(addprefix modules/, $(MYSQL_MODULES))
PERL_PKGNAME = opensips-perl-modules
PERL_MODULES = perl db_perlvdb
PERL_MOD_PATH=$(addprefix modules/, $(PERL_MODULES))
POSTGRES_PKGNAME = opensips-postgres-module
POSTGRES_DBSCHEMA_PKGNAME = opensips-postgres-dbschema
POSTGRES_MODULES = db_postgres
POSTGRES_MOD_PATH=$(addprefix modules/, $(POSTGRES_MODULES))
PRESENCE_PKGNAME = opensips-presence-modules
PRESENCE_MODULES = presence presence_callinfo presence_dialoginfo presence_reginfo presence_xml presence_mwi presence_xcapdiff presence_dfks pua pua_bla pua_dialoginfo pua_mi pua_reginfo pua_usrloc pua_xmpp rls xcap xcap_client
PRESENCE_MOD_PATH=$(addprefix modules/, $(PRESENCE_MODULES))
PROMETHEUS_PKGNAME = opensips-prometheus-module
PROMETHEUS_MODULES = prometheus
PROMETHEUS_MOD_PATH=$(addprefix modules/, $(PROMETHEUS_MODULES))
PROTO_SCTP_PKGNAME = opensips-sctp-module
PROTO_SCTP_MODULES = proto_sctp
PROTO_SCTP_MOD_PATH=$(addprefix modules/, $(PROTO_SCTP_MODULES))
PROTO_TLS_PKGNAME = opensips-tls-module
PROTO_TLS_MODULES = proto_tls
PROTO_TLS_MOD_PATH=$(addprefix modules/, $(PROTO_TLS_MODULES))
PROTO_WSS_PKGNAME = opensips-wss-module
PROTO_WSS_MODULES = proto_wss
PROTO_WSS_MOD_PATH=$(addprefix modules/, $(PROTO_WSS_MODULES))
PYTHON_PKGNAME = opensips-python-module
